% Example_5_1
%
%       Created for the book:                                                             
%   Ljiljana D. Milic,
%      Multirate Filtering for Digital Signal Processing: MATLAB Applications                     
%      Information Science Reference, Hershey, New York,  2009
%
clear all, close all
ap=0.1; as=60;
Fp=0.09; Fs=1/5;

% FIR filter design

dev = [(10^(ap/20)-1)/(10^(ap/20)+1)  10^(-as/20)]; 
F = [Fp 1/5];   % Cutoff frequencies
A = [1 0];      % Desired amplitudes
[Nord,Fo,Ao,W] = firpmord(F,A,dev)
h = firpm(Nord+4,Fo,Ao,W); % Filter coefficients
figure (1)
freqz(h,1,1024) % Computes and plots the frequency response
axis([0,1,-80,5])
hold 

% IIR filter design

ap=0.1; as=60;
Fp=0.09; 
[B,A]=ellip(5,ap,as,Fp); 
[z,p,k]=ellip(5,ap,as,Fp)
abs(p)'
figure (1)
freqz(B,A,1024) % Computes and plots the frequency response
axis([0,1,-80,5])

