% Example_5_3
%
%       Created for the book:                                                             
%   Ljiljana D. Milic,
%      Multirate Filtering for Digital Signal Processing: MATLAB Applications                     
%      Information Science Reference, Hershey, New York,  2009
%
% IIR and FIR polyphase filters
clear all, close all
% IIR filter poles
z01=-0.03247627480; z02=-0.4519480048; z03=-0.9477051753;
z11=-0.08029157130; z12=-0.5548998293;
z21=-0.1417079348; z22=-0.6883346404;
z31=-0.2320513100; z32=-0.7961481351;
z41=-0.3532045984; z42=-0.8755417392;
% Polyphase branches
a0=conv([1,-z01],[1,-z02]); a0=conv(a0,[1,-z03]);
a1=conv([1,-z11],[1,-z12]);
a2=conv([1,-z21],[1,-z22]);
a3=conv([1,-z31],[1,-z32]);
a4=conv([1,-z41],[1,-z42]);

A0=upsample(a0,5); A1=upsample(a1,5); A2=upsample(a2,5); A3=upsample(a3,5); A4=upsample(a4,5);
B0=fliplr(A0); B1=[0,fliplr(A1)]; B2=[0,0,fliplr(A2)]; B3=[0,0,0,fliplr(A3)]; B4=[0,0,0,0,fliplr(A4)]; 

% Computing the phase responses of polyphase branches
[PH0,f]=freqz(B0,A0,1024,2); [PH1,f]=freqz(B1,A1,1024,2); [PH2,f]=freqz(B2,A2,1024,2); [PH3,f]=freqz(B3,A3,1024,2); [PH4,f]=freqz(B4,A4,1024,2);

H=PH0+PH1+PH2+PH3+PH4;

[b,a]=ellip(5,0.1,43,0.8);
[HE,f]=freqz(b,a,1024,2);

bb=upsample(b,5);
aa=upsample(a,5);
[HEu,f]=freqz(bb,aa,1024,2);

Hover=(H/5).*HEu;

figure (1)
subplot(3,1,1)
plot(f,20*log10(abs(HE)))
ylabel('Gain, dB')
axis([0,1,-80,5])
grid
subplot(3,1,2)
plot(f,20*log10(abs(H)/5),'LineWidth',2), grid
hold on
plot(f,20*log10(abs(HEu)))
ylabel('Gain, dB')
axis([0,1,-80,5])
subplot(3,1,3)
plot(f,20*log10(abs(Hover)),'LineWidth',2)
xlabel('\omega/\pi')
ylabel('Gain, dB')
axis([0,1,-80,5])
grid

